/*
2010 KCNT roboken A team
Transmit data to RF module
PIC16F88

ver 1.0.0

recieve test mode


final update:10/09/17
*/

#define LED1 PORTB.F3
#define LED2 PORTB.F4

#define stop 30

#define time 24

unsigned short flag;
//flag bit parameter
/*
0bit: Recieve data
1-3bit: transmit count
*/
unsigned short stop_count;
//TXD STOP TIMER

unsigned short rc_data;
unsigned short rc_data_past;
unsigned short tx_data[4];

unsigned short ch;

unsigned short tmp;
unsigned short data;

unsigned short parity;

void interrupt(){
  if(INTCON.TMR0IF){
    TMR0=0xBA;
    ch=0;
    stop_count++;
    if(stop_count>=(stop+1)){
       stop_count=stop+1;
    }
    INTCON.TMR0IF=0;
    TMR2=PR2-1;
  }
  if(PIR1.TMR2IF){
    if(ch==0){//writing compare value
      CCPR1L=tx_data[0]-time;
      PR2=time;//0.4ms
      ch++;
    }else if(ch<4){
      PR2=CCPR1L+time;
      CCPR1L=tx_data[ch]-time;
      ch++;
    }else if(ch==4){
      PR2=CCPR1L+time;
      CCPR1L=92-time;
      ch++;
    }else if(ch==5){
      PR2=93;//N
      CCPR1L=0x00;
      ch++;
    }else{
      PR2=0xff;
    }
    PIR1.TMR2IF=0;
  }
  return;
}

unsigned short parity_check(unsigned short x){
  while(x&0xfe){
    if(x&0x01){
      if(x&0x02){
        x=x>>2;
      }else{
        x=x>>1;
        x+=1;
      }
    }else{
      x=x>>1;
    }
  }
  return x;
}

void init(){
  OSCCON=0x60;
  TRISB=0x04;
  PORTB=0xff;
  ANSEL=0x00;
  //Boud rate : 9600bps
  TXSTA=0x24;
  RCSTA=0x90;
  SPBRG=0x19;
  //RF TIMER
  //make 18ms
  INTCON=0xE0;
  //INTCON.TMR0IE=1;
  OPTION_REG=0x87;
  //INTCON.TMR0IF=0;
  
  //make signal
  //INTCON.GIE=1;
  PR2=0x7D;
  TMR2=0;
  T2CON=0x06;
  PIR1.TMR2IF=0;
  PIE1.TMR2IE=1;
  CCP1CON=0x0f;
  CCPR1L=0x00;


  tmp=0;
  data=0;
  flag=0;
  rc_data=0;
  rc_data_past=0;
  tx_data[0]=69;
  tx_data[1]=69;
  tx_data[2]=69;
  tx_data[3]=69;

  ch=0;
  
  return ;
}

main(){
  init();
  while(1){
    if(PIR1.RCIF){
      PIR1.RCIF=0;
      flag|=0x01;
      rc_data_past=rc_data;
      rc_data=RCREG;
      stop_count=0;
      if(rc_data==rc_data_past){
        tmp=flag&0x0e;
        if(tmp<7){
          tmp++;
        }
        flag&=0xf1;
        flag|=tmp<<1;
      }else{
        flag&=0xf1;
      }
    }else{
      if(stop_count==stop){
        LED2=0;
        TXREG=0x00;
        stop_count++;
        tx_data[0]=92;
        tx_data[1]=92;
        tx_data[2]=92;
        tx_data[3]=92;
      }
    }
    if((flag&0x01)&&(ch==6)){
      LED2=1;
      tmp=rc_data;
      //recieve UART
      //12bit=XXX YYY ZZP CCC
      //P=parity
      //CCC=count

      parity=parity_check(tmp);
      data=tmp&0x03;
      data=data<<1;
      data+=parity;
      if(data<=3){
        tx_data[2]=68;
      }else if(data>=4){
        tx_data[2]=99;
        data-=4;
      }
      while(data>0){
        tx_data[2]+=6;
        data--;
      }
      tmp=tmp>>2;
      data=tmp&0x07;
      if(data<=3){
        tx_data[1]=68;
      }else if(data>=4){
        tx_data[1]=99;
        data-=4;
      }
      while(data>0){
        tx_data[1]+=6;
        data--;
      }
      data=tmp>>3;
      if(data<=3){
        tx_data[0]=68;
      }else if(data>=4){
        tx_data[0]=99;
        data-=4;
      }
      while(data>0){
        tx_data[0]+=6;
        data--;
      }
      tmp=flag&0x0e;
      data=tmp>>1;
      if(data<=3){
        tx_data[3]=68;
      }else if(data>=4){
        tx_data[3]=99;
        data-=4;
      }
      while(data>0){
        tx_data[3]+=6;
        data--;
      }
      ch=0;
      TXREG=rc_data;
      flag&=0xfe;
    }
  }
}